namespace NXyn.Aux
    open System

    module IntMisc = 
        let is_power_of_two(i:int) = i &&& (i-1) = 0
        
        let rec find_power_of_two_lte(x:Int64) =
            let x0 = x - 1L
            let x1 = x &&& x0
            if x1 = 0L then x else find_power_of_two_lte(x1)


        let rec gcd64 a b = if b = 0L then a elif a = 0L then b else gcd64 b (a % b)

        let lsb(i:int) = if i <= 0 then failwith "lsb"
                         let rec loop n i = if i &&& 1 <> 0 then n else loop (n+1) (i >>> 1)
                         loop 0 i
