namespace NXyn.Aux
    open System
    open System.Collections
    open System.Collections.Generic
    
    module StringMisc =
        let (|BoolOfString|_|) (s:System.String) = if System.String.Compare(s,"true",true) = 0 then Some(true)
                                                   elif System.String.Compare(s,"false",true) = 0 then Some(false)
                                                   else None

        let (|Int32OfString|_|) (s:System.String) = try Some(int32(s)) with _ -> None

        let (|QuotedStringOfString|_|) (s:System.String) = let l = s.Length in if l >= 2 && s.[0] = '\"' && s.[l-1] = '\"' then Some(s.Substring(1,s.Length-2)) else None

        let (|ArgWithoutValue|_|) (optionName:System.String) (s:System.String) =
            if not(s.StartsWith("--")) then None
                                       else let sub = s.Substring(2)
                                            if System.String.Compare(sub, optionName, true) <> 0 then None
                                                                                                 else Some()

        let (|ArgWithValue|_|) (optionName:System.String) (s:System.String) =
            if not(s.StartsWith("--")) then None
                                       else let p1 = s.IndexOf(":")
                                            let p2 = s.IndexOf("=")
                                            let p = if p1 < 0 then p2 elif p2 < 0 then p1 else min p1 p2
                                            if p < 0 then None
                                                     else let sub = s.Substring(2, p-2)
                                                          let rest = s.Substring(p+1)
                                                          if System.String.Compare(sub, optionName, true) <> 0 then None
                                                                                                               else Some(rest)

