namespace NXyn.EmitFSharp

  open System
  open Microsoft.FSharp.Reflection
  open NXyn.EmitFSharp.Common


  module DispatchUnionNoArgs =


    let OutputCode (w:System.CodeDom.Compiler.IndentedTextWriter) (t:System.Type) (argidx:int) (methodname:string) (name:string) =
      if t.ContainsGenericParameters then failwith "EmitFSharpDispatchUnion.OutputCode: open types unsupported"
      if argidx < 0 then failwith "EmitFSharpDispatchUnion: invalid argument index"

      w.WriteLine("let {0} = function", name)
      w.Indent <- w.Indent + 1

      let tName = ClippedFSharpTypeName t.Name
      for (uc:UnionCaseInfo) in FSharpType.GetUnionCases t do
        let n = (uc.GetFields ()).Length
        if argidx >= n then failwith "EmitFSharpDispatchUnion.OutputCode: argument index out of range"
        WriteListLine w ("| " + tName + "." + uc.Name + "(") "," (") -> a" + string argidx + "." + methodname) n (fun i -> "a" + string i)

      w.Indent <- w.Indent - 1
      w.WriteLine(";;\n")
